<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Generated by Apache Maven Doxia Site Renderer 1.3 at Aug 1, 2017 -->
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=${outputEncoding}" />
    <title>CPD Results</title>
    <style type="text/css" media="all">
      @import url("./css/maven-base.css");
      @import url("./css/maven-theme.css");
      @import url("./css/site.css");
    </style>
    <link rel="stylesheet" href="./css/print.css" type="text/css" media="print" />
    <meta name="Date-Revision-yyyymmdd" content="20170801" />
    <meta http-equiv="Content-Language" content="en" />
        
        </head>
  <body class="composite">
    <div id="banner">
                      <div class="clear">
        <hr/>
      </div>
    </div>
    <div id="breadcrumbs">
            
            
                <div class="xleft">
        <span id="publishDate">Last Published: 2017-08-01</span>
                  &nbsp;| <span id="projectVersion">Version: ${project.version}</span>
                      </div>
            <div class="xright">        
            
      </div>
      <div class="clear">
        <hr/>
      </div>
    </div>
    <div id="leftColumn">
      <div id="navcolumn">
             
            
                                      <a href="http://maven.apache.org/" title="Built by Maven" class="poweredBy">
        <img class="poweredBy" alt="Built by Maven" src="./images/logos/maven-feather.png" />
      </a>
                   
            
            </div>
    </div>
    <div id="bodyColumn">
      <div id="contentBox">
        <div class="section"><h2>CPD Results<a name="CPD_Results"></a></h2><p>The following document contains the results of PMD's  <a class="externalLink" href="http://pmd.sourceforge.net/cpd.html">CPD</a> 5.0.5.</p></div><div class="section"><h2>Duplications<a name="Duplications"></a></h2><table align="center" border="0" class="bodyTable"><tr class="a"><th>File</th><th>Line</th></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/extensions/CopyOfVSLContextUtil.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/extensions/CopyOfVSLContextUtil.html#L158">158</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/extensions/VSLContextUtil.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/extensions/VSLContextUtil.html#L40">40</a></td></tr><tr class="b"><td colspan='2'><div><pre>		java.lang.reflect.Method m;
		try {
			Class&lt;?&gt;[] params = {};
			m = rule.eContainer().getClass().getMethod(&quot;getExpectedType&quot;, params);
		} catch (Exception e) {
			return org.eclipse.papyrus.marte.vsl.validation.VSLJavaValidator.getExpectedType();
		}
		try {
			Object[] args = {};
			return (Type) m.invoke(rule.eContainer(), args);
		} catch (Exception e) {
			return null;
		}
	}

	public static Namespace getModel(EObject rule) {
		java.lang.reflect.Method m;
		try {
			Class&lt;?&gt;[] params = {};
			m = rule.eContainer().getClass().getMethod(&quot;getModel&quot;, params);
		} catch (Exception e) {
			return org.eclipse.papyrus.marte.vsl.validation.VSLJavaValidator.getModel();
		}
		try {
			Object[] args = {};
			return (Namespace) m.invoke(rule.eContainer(), args);
		} catch (Exception e) {
			return null;
		}
	}

	public static Element getContextElement(EObject rule) {
		java.lang.reflect.Method m;
		try {
			Class&lt;?&gt;[] params = {};
			m = rule.eContainer().getClass().getDeclaredMethod(&quot;getContextElement&quot;, params);
		} catch (Exception e) {
			return org.eclipse.papyrus.marte.vsl.validation.VSLJavaValidator.getContextElement();
		}
		try {
			Object[] args = {};
			return (Element) m.invoke(rule.eContainer(), args);
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="a"><th>File</th><th>Line</th></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/extensions/CopyOfVSLContextUtil.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/extensions/CopyOfVSLContextUtil.html#L63">63</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/extensions/CopyOfVSLContextUtil.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/extensions/CopyOfVSLContextUtil.html#L247">247</a></td></tr><tr class="b"><td colspan='2'><div><pre>				int indexOfExpression = listOfValues.getValues().indexOf(container);
				if (listOfValues.eContainer() instanceof CollectionOrTuple) {
					Type typeOfCollectionOrTuple = ((CollectionOrTuple) listOfValues.eContainer()).getExpectedType();
					if (typeOfCollectionOrTuple.getAppliedStereotype(&quot;MARTE::MARTE_Annexes::VSL::DataTypes::CollectionType&quot;) != null) {
						Stereotype collectionStereotype = typeOfCollectionOrTuple.
								getAppliedStereotype(&quot;MARTE::MARTE_Annexes::VSL::DataTypes::CollectionType&quot;);
						EObject stereotypeApplication = typeOfCollectionOrTuple.getStereotypeApplication(collectionStereotype);
						EStructuralFeature collectionAttrib = stereotypeApplication.eClass().getEStructuralFeature(&quot;collectionAttrib&quot;);
						if (collectionAttrib != null) {
							Property collectionProperty = (Property) stereotypeApplication.eGet(collectionAttrib);
							return collectionProperty.getType();
						}
					}
					else if (typeOfCollectionOrTuple.getAppliedStereotype(&quot;MARTE::MARTE_Annexes::VSL::DataTypes::TupleType&quot;) != null ||
							typeOfCollectionOrTuple.getAppliedStereotype(&quot;MARTE::MARTE_Foundations::NFPs::NfpType&quot;) != null) {
						if (indexOfExpression &lt; ((Classifier) typeOfCollectionOrTuple).getAllAttributes().size()) {
							return expectedType = ((Classifier) typeOfCollectionOrTuple).getAllAttributes().get(indexOfExpression).getType();
						}
					}

				}
				else if (listOfValues.eContainer() instanceof NameOrChoiceOrBehaviorCall) {
					NameOrChoiceOrBehaviorCall call = (NameOrChoiceOrBehaviorCall) listOfValues.eContainer();
					if (call.getId() != null &amp;&amp; call.getId() instanceof Behavior) {
						Behavior calledBehavior = (Behavior) call.getId();
						if (indexOfExpression &lt; calledBehavior.getOwnedParameters().size()) {
							return calledBehavior.getOwnedParameters().get(indexOfExpression).getType();
						}
					}</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="a"><th>File</th><th>Line</th></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/services/VSLGrammarAccess.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/services/VSLGrammarAccess.html#L1506">1506</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/services/VSLGrammarAccess.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/services/VSLGrammarAccess.html#L1656">1656</a></td></tr><tr class="b"><td colspan='2'><div><pre>		private final RuleCall cIdInstantObsNameParserRuleCall_1_0 = (RuleCall) cIdAssignment_1.eContents().get(0);
		private final Group cGroup_2 = (Group) cGroup.eContents().get(2);
		private final Keyword cLeftParenthesisKeyword_2_0 = (Keyword) cGroup_2.eContents().get(0);
		private final Assignment cIndexAssignment_2_1 = (Assignment) cGroup_2.eContents().get(1);
		private final RuleCall cIndexExpressionParserRuleCall_2_1_0 = (RuleCall) cIndexAssignment_2_1.eContents().get(0);
		private final Keyword cRightParenthesisKeyword_2_2 = (Keyword) cGroup_2.eContents().get(2);
		private final Group cGroup_3 = (Group) cGroup.eContents().get(3);
		private final Keyword cWhenKeyword_3_0 = (Keyword) cGroup_3.eContents().get(0);
		private final Keyword cLeftParenthesisKeyword_3_1 = (Keyword) cGroup_3.eContents().get(1);
		private final Assignment cConditionAssignment_3_2 = (Assignment) cGroup_3.eContents().get(2);
		private final RuleCall cConditionExpressionParserRuleCall_3_2_0 = (RuleCall) cConditionAssignment_3_2.eContents().get(0);
		private final Keyword cRightParenthesisKeyword_3_3 = (Keyword) cGroup_3.eContents().get(3);

		// InstantObsExpression:
		//
		// &quot;@&quot; id=InstantObsName (&quot;(&quot; index=Expression &quot;)&quot;)? (&quot;when&quot; &quot;(&quot; condition=Expression &quot;)&quot;)?;
		@Override
		public ParserRule getRule() {
			return rule;
		}

		// &quot;@&quot; id=InstantObsName (&quot;(&quot; index=Expression &quot;)&quot;)? (&quot;when&quot; &quot;(&quot; condition=Expression &quot;)&quot;)?
		public Group getGroup() {
			return cGroup;
		}

		// &quot;@&quot;
		public Keyword getCommercialAtKeyword_0() {</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="a"><th>File</th><th>Line</th></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/parser/antlr/internal/InternalVSLLexer.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parser/antlr/internal/InternalVSLLexer.html#L47">47</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/parser/antlr/internal/InternalVSLParser.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parser/antlr/internal/InternalVSLParser.html#L52">52</a></td></tr><tr class="b"><td colspan='2'><div><pre>	public static final int T__16 = 16;
	public static final int T__51 = 51;
	public static final int T__18 = 18;
	public static final int T__17 = 17;
	public static final int RULE_INT = 11;
	public static final int T__50 = 50;
	public static final int RULE_NULLLITERAL = 9;
	public static final int T__42 = 42;
	public static final int T__43 = 43;
	public static final int T__40 = 40;
	public static final int T__41 = 41;
	public static final int T__46 = 46;
	public static final int T__47 = 47;
	public static final int T__44 = 44;
	public static final int T__45 = 45;
	public static final int T__48 = 48;
	public static final int T__49 = 49;
	public static final int RULE_INTEGERLITERAL = 5;
	public static final int RULE_SL_COMMENT = 13;
	public static final int RULE_ML_COMMENT = 12;
	public static final int T__30 = 30;
	public static final int T__31 = 31;
	public static final int RULE_STRING = 10;
	public static final int T__32 = 32;
	public static final int T__33 = 33;
	public static final int T__34 = 34;
	public static final int T__35 = 35;
	public static final int T__36 = 36;
	public static final int T__37 = 37;
	public static final int T__38 = 38;
	public static final int T__39 = 39;
	public static final int RULE_WS = 14;

	// delegates
	// delegators

	public InternalVSLLexer() {</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="a"><th>File</th><th>Line</th></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L2147">2147</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L3209">3209</a></td></tr><tr class="b"><td colspan='2'><div><pre>				return new Literal_Alternatives(this, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if (getEObject().eClass() != grammarAccess.getBooleanLiteralRuleRule().getType().getClassifier() &amp;&amp;
					getEObject().eClass() != grammarAccess.getDateTimeLiteralRuleRule().getType().getClassifier() &amp;&amp;
					getEObject().eClass() != grammarAccess.getDefaultLiteralRuleRule().getType().getClassifier() &amp;&amp;
					getEObject().eClass() != grammarAccess.getIntegerLiteralRuleRule().getType().getClassifier() &amp;&amp;
					getEObject().eClass() != grammarAccess.getNullLiteralRuleRule().getType().getClassifier() &amp;&amp;
					getEObject().eClass() != grammarAccess.getRealLiteralRuleRule().getType().getClassifier() &amp;&amp;
					getEObject().eClass() != grammarAccess.getStringLiteralRuleRule().getType().getClassifier() &amp;&amp;
					getEObject().eClass() != grammarAccess.getUnlimitedLiteralRuleRule().getType().getClassifier()) {
				return null;
			}</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="a"><th>File</th><th>Line</th></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/scoping/VSLScopeProvider.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/scoping/VSLScopeProvider.html#L728">728</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/scoping/VSLScopeProvider.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/scoping/VSLScopeProvider.html#L793">793</a></td></tr><tr class="b"><td colspan='2'><div><pre>				tmpVisiblePropertiesFromPath.addAll(ScopingVisitors.ownedAndImportedDurationObservations.visit(nearestNamespace));
				for (Element e : tmpVisiblePropertiesFromPath) {
					if (!tmpFlatListOfVisibleElements.contains(e)) {
						tmpVisibleElementsFromPath.add(e);
					}
				}
			}
		}

		// builds the nested scope base on hierarchy and then inheritance
		SimpleScope resultScope = null;

		Iterable&lt;IEObjectDescription&gt; iterableIEobjectDescriptions;
		if (!tmpVisibleElementsFromPath.isEmpty()) {
			iterableIEobjectDescriptions = Scopes.scopedElementsFor(tmpVisibleElementsFromPath);
			resultScope = resultScope != null ? new SimpleScope(resultScope, iterableIEobjectDescriptions) : new SimpleScope(iterableIEobjectDescriptions);
		}
		for (List&lt;Element&gt; l : tmpHierarchichallyVisibleElements) {
			if (!l.isEmpty()) {
				iterableIEobjectDescriptions = Scopes.scopedElementsFor(l);
				resultScope = resultScope != null ? new SimpleScope(resultScope, iterableIEobjectDescriptions) : new SimpleScope(iterableIEobjectDescriptions);
			}
		}

		return resultScope != null ? resultScope : new SimpleScope(Scopes.scopedElementsFor(new ArrayList&lt;Element&gt;()));
	}

	/* ****************************************************
	 *
	 * Scope for data types (used to type local variables)
	 *
	 * ***************************************************
	 */

	public IScope scope_DataTypeName_type(DataTypeName ctx, EReference ref) {</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="a"><th>File</th><th>Line</th></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/scoping/VSLScopeProvider.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/scoping/VSLScopeProvider.html#L703">703</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/scoping/VSLScopeProvider.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/scoping/VSLScopeProvider.html#L768">768</a></td></tr><tr class="b"><td colspan='2'><div><pre>		tmpHierarchichallyVisibleElements.addAll(ScopingVisitors.hierarchichallyAccessibleDurationObservations.visit(context));
		for (List&lt;Element&gt; l : tmpHierarchichallyVisibleElements) {
			List&lt;Element&gt; elementsToBeRemovedFromTheScope = new ArrayList&lt;Element&gt;();
			for (Element e : l) {
				if (tmpFlatListOfVisibleElements.contains(e)) {
					// The element has already been considered by inheritance scoping,
					// and must not be considered by hierarchy scoping
					elementsToBeRemovedFromTheScope.add(e);
				}
				tmpFlatListOfVisibleElements.addAll(l);
			}
			l.removeAll(elementsToBeRemovedFromTheScope);
		}

		// In the case where a path (qualified name prefix) has been specified,
		// retrieves visible elements from this name space
		List&lt;Element&gt; tmpVisibleElementsFromPath = new ArrayList&lt;Element&gt;();
		if (ctx.getPath() != null) {
			QualifiedName qualifiedName = ctx.getPath();
			while (qualifiedName.getRemaining() != null) {
				qualifiedName = qualifiedName.getRemaining();
			}
			Namespace nearestNamespace = qualifiedName.getPath();
			if (nearestNamespace != null) {
				List&lt;Element&gt; tmpVisiblePropertiesFromPath = new ArrayList&lt;Element&gt;();
				tmpVisiblePropertiesFromPath.addAll(ScopingVisitors.ownedAndImportedDurationObservations.visit(nearestNamespace));</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="a"><th>File</th><th>Line</th></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/scoping/VSLScopeProvider.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/scoping/VSLScopeProvider.html#L829">829</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/scoping/VSLScopeProvider.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/scoping/VSLScopeProvider.html#L867">867</a></td></tr><tr class="b"><td colspan='2'><div><pre>		List&lt;List&lt;Element&gt;&gt; visibleProperties = new ArrayList&lt;List&lt;Element&gt;&gt;();
		Classifier expectedTypeForScoping = null;
		if (ctx.eContainer() instanceof PrimaryExpression) {
			PrimaryExpression primary = (PrimaryExpression) ctx.eContainer();
			if (primary.getPrefix() instanceof NameOrChoiceOrBehaviorCall) {
				NameOrChoiceOrBehaviorCall n = (NameOrChoiceOrBehaviorCall) primary.getPrefix();
				if (n.getId() instanceof Property) {
					expectedTypeForScoping = (Classifier) ((Property) n.getId()).getType();
				} else {
					expectedTypeForScoping = new ScopingHelper(ctx.eContainer()).getClassifierForScoping();
				}
			} else {
				expectedTypeForScoping = new ScopingHelper(ctx.eContainer()).getClassifierForScoping();
			}
		} else {
			expectedTypeForScoping = new ScopingHelper(ctx.eContainer()).getClassifierForScoping();
		}
		if (expectedTypeForScoping != null) {</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="a"><th>File</th><th>Line</th></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/parser/antlr/internal/InternalVSLLexer.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parser/antlr/internal/InternalVSLLexer.html#L2113">2113</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/parser/antlr/internal/InternalVSLLexer.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parser/antlr/internal/InternalVSLLexer.html#L2174">2174</a></td></tr><tr class="b"><td colspan='2'><div><pre>						switch (alt30) {
						case 1:
						// ../org.eclipse.papyrus.marte.vsl/src-gen/org/eclipse/papyrus/marte/vsl/parser/antlr/internal/InternalVSL.g:2744:21: '\\\\' ( 'b' | 't' | 'n' | 'f' | 'r' | 'u' | '\&quot;' | '\\'' | '\\\\' )
						{
							match('\\');
							if (input.LA(1) == '\&quot;' || input.LA(1) == '\'' || input.LA(1) == '\\' || input.LA(1) == 'b' || input.LA(1) == 'f' || input.LA(1) == 'n' || input.LA(1) == 'r' || (input.LA(1) &gt;= 't' &amp;&amp; input.LA(1) &lt;= 'u')) {
								input.consume();

							}
							else {
								MismatchedSetException mse = new MismatchedSetException(null, input);
								recover(mse);
								throw mse;
							}


						}
							break;
						case 2:
						// ../org.eclipse.papyrus.marte.vsl/src-gen/org/eclipse/papyrus/marte/vsl/parser/antlr/internal/InternalVSL.g:2744:66: ~ ( ( '\\\\' | '\&quot;' ) )
						{
							if ((input.LA(1) &gt;= '\u0000' &amp;&amp; input.LA(1) &lt;= '!') || (input.LA(1) &gt;= '#' &amp;&amp; input.LA(1) &lt;= '[') || (input.LA(1) &gt;= ']' &amp;&amp; input.LA(1) &lt;= '\uFFFF')) {</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="a"><th>File</th><th>Line</th></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L253">253</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L379">379</a></td></tr><tr class="b"><td colspan='2'><div><pre>			return grammarAccess.getAndOrXorExpressionAccess().getExpAssignment_0();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch (index) {
			case 0:
				return new EqualityExpression_Group(this, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if ((value = eObjectConsumer.getConsumable(&quot;exp&quot;, true)) == null) {
				return null;
			}
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume(&quot;exp&quot;);
			if (value instanceof EObject) { // org::eclipse::xtext::impl::RuleCallImpl
				IEObjectConsumer param = createEObjectConsumer((EObject) value);
				if (param.isInstanceOf(grammarAccess.getEqualityExpressionRule().getType().getClassifier())) {
					type = AssignmentType.PARSER_RULE_CALL;
					element = grammarAccess.getAndOrXorExpressionAccess().getExpEqualityExpressionParserRuleCall_0_0();</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="a"><th>File</th><th>Line</th></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L481">481</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L602">602</a></td></tr><tr class="b"><td colspan='2'><div><pre>			return grammarAccess.getEqualityExpressionAccess().getExpAssignment_0();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch (index) {
			case 0:
				return new RelationalExpression_Group(this, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if ((value = eObjectConsumer.getConsumable(&quot;exp&quot;, true)) == null) {
				return null;
			}
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume(&quot;exp&quot;);
			if (value instanceof EObject) { // org::eclipse::xtext::impl::RuleCallImpl
				IEObjectConsumer param = createEObjectConsumer((EObject) value);
				if (param.isInstanceOf(grammarAccess.getRelationalExpressionRule().getType().getClassifier())) {
					type = AssignmentType.PARSER_RULE_CALL;
					element = grammarAccess.getEqualityExpressionAccess().getExpRelationalExpressionParserRuleCall_0_0();</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="a"><th>File</th><th>Line</th></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L704">704</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L835">835</a></td></tr><tr class="b"><td colspan='2'><div><pre>			return grammarAccess.getRelationalExpressionAccess().getExpAssignment_0();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch (index) {
			case 0:
				return new ConditionalExpression_Group(this, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if ((value = eObjectConsumer.getConsumable(&quot;exp&quot;, true)) == null) {
				return null;
			}
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume(&quot;exp&quot;);
			if (value instanceof EObject) { // org::eclipse::xtext::impl::RuleCallImpl
				IEObjectConsumer param = createEObjectConsumer((EObject) value);
				if (param.isInstanceOf(grammarAccess.getConditionalExpressionRule().getType().getClassifier())) {
					type = AssignmentType.PARSER_RULE_CALL;
					element = grammarAccess.getRelationalExpressionAccess().getExpConditionalExpressionParserRuleCall_0_0();</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="a"><th>File</th><th>Line</th></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L937">937</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L1051">1051</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L1129">1129</a></td></tr><tr class="a"><td colspan='2'><div><pre>			return grammarAccess.getConditionalExpressionAccess().getExpAssignment_0();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch (index) {
			case 0:
				return new AdditiveExpression_Group(this, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if ((value = eObjectConsumer.getConsumable(&quot;exp&quot;, true)) == null) {
				return null;
			}
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume(&quot;exp&quot;);
			if (value instanceof EObject) { // org::eclipse::xtext::impl::RuleCallImpl
				IEObjectConsumer param = createEObjectConsumer((EObject) value);
				if (param.isInstanceOf(grammarAccess.getAdditiveExpressionRule().getType().getClassifier())) {
					type = AssignmentType.PARSER_RULE_CALL;
					element = grammarAccess.getConditionalExpressionAccess().getExpAdditiveExpressionParserRuleCall_0_0();</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="b"><th>File</th><th>Line</th></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L1231">1231</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L1352">1352</a></td></tr><tr class="a"><td colspan='2'><div><pre>			return grammarAccess.getAdditiveExpressionAccess().getExpAssignment_0();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch (index) {
			case 0:
				return new MultiplicativeExpression_Group(this, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if ((value = eObjectConsumer.getConsumable(&quot;exp&quot;, true)) == null) {
				return null;
			}
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume(&quot;exp&quot;);
			if (value instanceof EObject) { // org::eclipse::xtext::impl::RuleCallImpl
				IEObjectConsumer param = createEObjectConsumer((EObject) value);
				if (param.isInstanceOf(grammarAccess.getMultiplicativeExpressionRule().getType().getClassifier())) {
					type = AssignmentType.PARSER_RULE_CALL;
					element = grammarAccess.getAdditiveExpressionAccess().getExpMultiplicativeExpressionParserRuleCall_0_0();</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="b"><th>File</th><th>Line</th></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L1454">1454</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L1580">1580</a></td></tr><tr class="a"><td colspan='2'><div><pre>			return grammarAccess.getMultiplicativeExpressionAccess().getExpAssignment_0();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch (index) {
			case 0:
				return new UnaryExpression_Alternatives(this, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if ((value = eObjectConsumer.getConsumable(&quot;exp&quot;, true)) == null) {
				return null;
			}
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume(&quot;exp&quot;);
			if (value instanceof EObject) { // org::eclipse::xtext::impl::RuleCallImpl
				IEObjectConsumer param = createEObjectConsumer((EObject) value);
				if (param.isInstanceOf(grammarAccess.getUnaryExpressionRule().getType().getClassifier())) {
					type = AssignmentType.PARSER_RULE_CALL;
					element = grammarAccess.getMultiplicativeExpressionAccess().getExpUnaryExpressionParserRuleCall_0_0();</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="b"><th>File</th><th>Line</th></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L2006">2006</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L2829">2829</a></td></tr><tr class="a"><td colspan='2'><div><pre>			return grammarAccess.getPrimaryExpressionAccess().getSuffixAssignment_1_1();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch (index) {
			case 0:
				return new SuffixExpression_Alternatives(this, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if ((value = eObjectConsumer.getConsumable(&quot;suffix&quot;, false)) == null) {
				return null;
			}
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume(&quot;suffix&quot;);
			if (value instanceof EObject) { // org::eclipse::xtext::impl::RuleCallImpl
				IEObjectConsumer param = createEObjectConsumer((EObject) value);
				if (param.isInstanceOf(grammarAccess.getSuffixExpressionRule().getType().getClassifier())) {
					type = AssignmentType.PARSER_RULE_CALL;
					element = grammarAccess.getPrimaryExpressionAccess().getSuffixSuffixExpressionParserRuleCall_1_1_0();</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="b"><th>File</th><th>Line</th></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L3556">3556</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L5778">5778</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L6321">6321</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L7291">7291</a></td></tr><tr class="a"><td colspan='2'><div><pre>			return grammarAccess.getNameOrChoiceOrBehaviorCallAccess().getPathAssignment_0();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch (index) {
			case 0:
				return new QualifiedName_Group(this, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if ((value = eObjectConsumer.getConsumable(&quot;path&quot;, false)) == null) {
				return null;
			}
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume(&quot;path&quot;);
			if (value instanceof EObject) { // org::eclipse::xtext::impl::RuleCallImpl
				IEObjectConsumer param = createEObjectConsumer((EObject) value);
				if (param.isInstanceOf(grammarAccess.getQualifiedNameRule().getType().getClassifier())) {
					type = AssignmentType.PARSER_RULE_CALL;
					element = grammarAccess.getNameOrChoiceOrBehaviorCallAccess().getPathQualifiedNameParserRuleCall_0_0();</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="b"><th>File</th><th>Line</th></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L5501">5501</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L6044">6044</a></td></tr><tr class="a"><td colspan='2'><div><pre>			return grammarAccess.getInstantObsExpressionAccess().getIndexAssignment_2_1();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch (index) {
			case 0:
				return new Expression_ExpAssignment(this, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if ((value = eObjectConsumer.getConsumable(&quot;index&quot;, false)) == null) {
				return null;
			}
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume(&quot;index&quot;);
			if (value instanceof EObject) { // org::eclipse::xtext::impl::RuleCallImpl
				IEObjectConsumer param = createEObjectConsumer((EObject) value);
				if (param.isInstanceOf(grammarAccess.getExpressionRule().getType().getClassifier())) {
					type = AssignmentType.PARSER_RULE_CALL;
					element = grammarAccess.getInstantObsExpressionAccess().getIndexExpressionParserRuleCall_2_1_0();</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="b"><th>File</th><th>Line</th></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L5654">5654</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L6197">6197</a></td></tr><tr class="a"><td colspan='2'><div><pre>			return grammarAccess.getInstantObsExpressionAccess().getConditionAssignment_3_2();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch (index) {
			case 0:
				return new Expression_ExpAssignment(this, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if ((value = eObjectConsumer.getConsumable(&quot;condition&quot;, false)) == null) {
				return null;
			}
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume(&quot;condition&quot;);
			if (value instanceof EObject) { // org::eclipse::xtext::impl::RuleCallImpl
				IEObjectConsumer param = createEObjectConsumer((EObject) value);
				if (param.isInstanceOf(grammarAccess.getExpressionRule().getType().getClassifier())) {
					type = AssignmentType.PARSER_RULE_CALL;
					element = grammarAccess.getInstantObsExpressionAccess().getConditionExpressionParserRuleCall_3_2_0();</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="b"><th>File</th><th>Line</th></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L2006">2006</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L2829">2829</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L3122">3122</a></td></tr><tr class="b"><td colspan='2'><div><pre>			return grammarAccess.getPrimaryExpressionAccess().getSuffixAssignment_1_1();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch (index) {
			case 0:
				return new SuffixExpression_Alternatives(this, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if ((value = eObjectConsumer.getConsumable(&quot;suffix&quot;, false)) == null) {
				return null;
			}
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume(&quot;suffix&quot;);
			if (value instanceof EObject) { // org::eclipse::xtext::impl::RuleCallImpl
				IEObjectConsumer param = createEObjectConsumer((EObject) value);
				if (param.isInstanceOf(grammarAccess.getSuffixExpressionRule().getType().getClassifier())) {
					type = AssignmentType.PARSER_RULE_CALL;
					element = grammarAccess.getPrimaryExpressionAccess().getSuffixSuffixExpressionParserRuleCall_1_1_0();</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="a"><th>File</th><th>Line</th></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L2994">2994</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L3697">3697</a></td></tr><tr class="b"><td colspan='2'><div><pre>			return grammarAccess.getOperationCallExpressionAccess().getArgumentsAssignment_2();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch (index) {
			case 0:
				return new ListOfValues_Group(this, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if ((value = eObjectConsumer.getConsumable(&quot;arguments&quot;, false)) == null) {
				return null;
			}
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume(&quot;arguments&quot;);
			if (value instanceof EObject) { // org::eclipse::xtext::impl::RuleCallImpl
				IEObjectConsumer param = createEObjectConsumer((EObject) value);
				if (param.isInstanceOf(grammarAccess.getListOfValuesRule().getType().getClassifier())) {
					type = AssignmentType.PARSER_RULE_CALL;
					element = grammarAccess.getOperationCallExpressionAccess().getArgumentsListOfValuesParserRuleCall_2_0();</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="a"><th>File</th><th>Line</th></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/scoping/VSLScopeProvider.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/scoping/VSLScopeProvider.html#L667">667</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/scoping/VSLScopeProvider.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/scoping/VSLScopeProvider.html#L734">734</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/scoping/VSLScopeProvider.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/scoping/VSLScopeProvider.html#L799">799</a></td></tr><tr class="a"><td colspan='2'><div><pre>			}
		}

		// builds the nested scope base on hierarchy and then inheritance
		SimpleScope resultScope = null;

		Iterable&lt;IEObjectDescription&gt; iterableIEobjectDescriptions;
		if (!tmpVisibleElementsFromPath.isEmpty()) {
			iterableIEobjectDescriptions = Scopes.scopedElementsFor(tmpVisibleElementsFromPath);
			resultScope = resultScope != null ? new SimpleScope(resultScope, iterableIEobjectDescriptions) : new SimpleScope(iterableIEobjectDescriptions);
		}
		for (List&lt;Element&gt; l : tmpHierarchichallyVisibleElements) {
			if (!l.isEmpty()) {
				iterableIEobjectDescriptions = Scopes.scopedElementsFor(l);
				resultScope = resultScope != null ? new SimpleScope(resultScope, iterableIEobjectDescriptions) : new SimpleScope(iterableIEobjectDescriptions);
			}
		}

		return resultScope != null ? resultScope : new SimpleScope(Scopes.scopedElementsFor(new ArrayList&lt;Element&gt;()));

	}

	/* ****************************************************
	 *
	 * Scope for names of duration observation
	 *
	 * ***************************************************
	 */


	public IScope scope_DurationObsName_durationId(DurationObsName ctx, EReference ref) {</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="b"><th>File</th><th>Line</th></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/DurationObsExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/DurationObsExpressionImpl.html#L285">285</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/InstantObsExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/InstantObsExpressionImpl.html#L285">285</a></td></tr><tr class="a"><td colspan='2'><div><pre>			eNotify(new ENotificationImpl(this, Notification.SET, VSLPackage.DURATION_OBS_EXPRESSION__CONDITION, newCondition, newCondition));
		}
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public EObject getFilteredParentRule(final EClass filter)
	{
		return org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil.getFilteredParentRule(this, filter);
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public Type getExpectedType()
	{
		return org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil.getExpectedType(this);
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public Element getContextElement()
	{
		return org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil.getContextElement(this);
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
	{
		switch (featureID)
		{
		case VSLPackage.DURATION_OBS_EXPRESSION__ID:</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="b"><th>File</th><th>Line</th></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/ExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/ExpressionImpl.html#L136">136</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/UnaryExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/UnaryExpressionImpl.html#L262">262</a></td></tr><tr class="a"><td colspan='2'><div><pre>			eNotify(new ENotificationImpl(this, Notification.SET, VSLPackage.EXPRESSION__EXP, newExp, newExp));
		}
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public EObject getFilteredParentRule(final EClass filter)
	{
		return org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil.getFilteredParentRule(this, filter);
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public Type getExpectedType()
	{
		return org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil.getExpectedType(this);
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public Element getContextElement()
	{
		return org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil.getContextElement(this);
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
	{
		switch (featureID)
		{
		case VSLPackage.EXPRESSION__EXP:</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="b"><th>File</th><th>Line</th></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/NameOrChoiceOrBehaviorCallImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/NameOrChoiceOrBehaviorCallImpl.html#L274">274</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/OperationCallExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/OperationCallExpressionImpl.html#L199">199</a></td></tr><tr class="a"><td colspan='2'><div><pre>			eNotify(new ENotificationImpl(this, Notification.SET, VSLPackage.NAME_OR_CHOICE_OR_BEHAVIOR_CALL__ARGUMENTS, newArguments, newArguments));
		}
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public EObject getFilteredParentRule(final EClass filter)
	{
		return org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil.getFilteredParentRule(this, filter);
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public Type getExpectedType()
	{
		return org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil.getExpectedType(this);
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public Element getContextElement()
	{
		return org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil.getContextElement(this);
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
	{
		switch (featureID)
		{
		case VSLPackage.NAME_OR_CHOICE_OR_BEHAVIOR_CALL__PATH:</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="b"><th>File</th><th>Line</th></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/PrimaryExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/PrimaryExpressionImpl.html#L212">212</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/SuffixExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/SuffixExpressionImpl.html#L136">136</a></td></tr><tr class="a"><td colspan='2'><div><pre>			eNotify(new ENotificationImpl(this, Notification.SET, VSLPackage.PRIMARY_EXPRESSION__SUFFIX, newSuffix, newSuffix));
		}
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public EObject getFilteredParentRule(final EClass filter)
	{
		return org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil.getFilteredParentRule(this, filter);
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public Type getExpectedType()
	{
		return org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil.getExpectedType(this);
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public Element getContextElement()
	{
		return org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil.getContextElement(this);
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
	{
		switch (featureID)
		{
		case VSLPackage.PRIMARY_EXPRESSION__PREFIX:</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="b"><th>File</th><th>Line</th></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/AdditiveExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/AdditiveExpressionImpl.html#L122">122</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/AndOrXorExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/AndOrXorExpressionImpl.html#L122">122</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/ConditionalExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/ConditionalExpressionImpl.html#L122">122</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/EqualityExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/EqualityExpressionImpl.html#L122">122</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/MultiplicativeExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/MultiplicativeExpressionImpl.html#L122">122</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/RelationalExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/RelationalExpressionImpl.html#L122">122</a></td></tr><tr class="a"><td colspan='2'><div><pre>			op = new EDataTypeEList&lt;String&gt;(String.class, this, VSLPackage.ADDITIVE_EXPRESSION__OP);
		}
		return op;
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public EObject getFilteredParentRule(final EClass filter)
	{
		return org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil.getFilteredParentRule(this, filter);
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public Type getExpectedType()
	{
		return org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil.getExpectedType(this);
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public Element getContextElement()
	{
		return org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil.getContextElement(this);
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
	{
		switch (featureID)
		{
		case VSLPackage.ADDITIVE_EXPRESSION__EXP:</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="b"><th>File</th><th>Line</th></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/CollectionOrTupleImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/CollectionOrTupleImpl.html#L136">136</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/DataTypeNameImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/DataTypeNameImpl.html#L200">200</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/DurationObsExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/DurationObsExpressionImpl.html#L285">285</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/DurationObsNameImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/DurationObsNameImpl.html#L200">200</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/ExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/ExpressionImpl.html#L136">136</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/InstantObsExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/InstantObsExpressionImpl.html#L285">285</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/InstantObsNameImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/InstantObsNameImpl.html#L200">200</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/IntervalImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/IntervalImpl.html#L312">312</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/JitterExpImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/JitterExpImpl.html#L210">210</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/NameOrChoiceOrBehaviorCallImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/NameOrChoiceOrBehaviorCallImpl.html#L274">274</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/OperationCallExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/OperationCallExpressionImpl.html#L199">199</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/PrimaryExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/PrimaryExpressionImpl.html#L212">212</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/QualifiedNameImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/QualifiedNameImpl.html#L199">199</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/SuffixExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/SuffixExpressionImpl.html#L136">136</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/TupleImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/TupleImpl.html#L136">136</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/UnaryExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/UnaryExpressionImpl.html#L262">262</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/ValueNamePairImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/ValueNamePairImpl.html#L200">200</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/VariableDeclarationImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/VariableDeclarationImpl.html#L313">313</a></td></tr><tr class="a"><td colspan='2'><div><pre>			eNotify(new ENotificationImpl(this, Notification.SET, VSLPackage.COLLECTION_OR_TUPLE__LIST_OF_VALUES, newListOfValues, newListOfValues));
		}
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public EObject getFilteredParentRule(final EClass filter)
	{
		return org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil.getFilteredParentRule(this, filter);
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public Type getExpectedType()
	{
		return org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil.getExpectedType(this);
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public Element getContextElement()
	{
		return org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil.getContextElement(this);
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
	{
		switch (featureID)
		{
		case VSLPackage.COLLECTION_OR_TUPLE__LIST_OF_VALUES:</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="b"><th>File</th><th>Line</th></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/LiteralImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/LiteralImpl.html#L110">110</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/PropertyCallExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/PropertyCallExpressionImpl.html#L123">123</a></td></tr><tr class="a"><td colspan='2'><div><pre>			eNotify(new ENotificationImpl(this, Notification.SET, VSLPackage.LITERAL__VALUE, oldValue, value));
		}
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public EObject getFilteredParentRule(final EClass filter)
	{
		return org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil.getFilteredParentRule(this, filter);
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public Type getExpectedType()
	{
		return org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil.getExpectedType(this);
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public Element getContextElement()
	{
		return org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil.getContextElement(this);
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType)
	{
		switch (featureID)
		{
		case VSLPackage.LITERAL__VALUE:</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="b"><th>File</th><th>Line</th></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/AdditiveExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/AdditiveExpressionImpl.html#L125">125</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/AndOrXorExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/AndOrXorExpressionImpl.html#L125">125</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/CollectionOrTupleImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/CollectionOrTupleImpl.html#L138">138</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/ConditionalExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/ConditionalExpressionImpl.html#L125">125</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/DataTypeNameImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/DataTypeNameImpl.html#L202">202</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/DurationObsExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/DurationObsExpressionImpl.html#L287">287</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/DurationObsNameImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/DurationObsNameImpl.html#L202">202</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/EqualityExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/EqualityExpressionImpl.html#L125">125</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/ExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/ExpressionImpl.html#L138">138</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/InstantObsExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/InstantObsExpressionImpl.html#L287">287</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/InstantObsNameImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/InstantObsNameImpl.html#L202">202</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/IntervalImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/IntervalImpl.html#L314">314</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/JitterExpImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/JitterExpImpl.html#L212">212</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/ListOfValueNamePairsImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/ListOfValueNamePairsImpl.html#L96">96</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/ListOfValuesImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/ListOfValuesImpl.html#L96">96</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/MultiplicativeExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/MultiplicativeExpressionImpl.html#L125">125</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/NameOrChoiceOrBehaviorCallImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/NameOrChoiceOrBehaviorCallImpl.html#L276">276</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/OperationCallExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/OperationCallExpressionImpl.html#L201">201</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/PrimaryExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/PrimaryExpressionImpl.html#L214">214</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/QualifiedNameImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/QualifiedNameImpl.html#L201">201</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/RelationalExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/RelationalExpressionImpl.html#L125">125</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/SuffixExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/SuffixExpressionImpl.html#L138">138</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/TupleImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/TupleImpl.html#L138">138</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/UnaryExpressionImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/UnaryExpressionImpl.html#L264">264</a></td></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/ValueNamePairImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/ValueNamePairImpl.html#L202">202</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/vSL/impl/VariableDeclarationImpl.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/vSL/impl/VariableDeclarationImpl.html#L315">315</a></td></tr><tr class="a"><td colspan='2'><div><pre>	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public EObject getFilteredParentRule(final EClass filter)
	{
		return org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil.getFilteredParentRule(this, filter);
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public Type getExpectedType()
	{
		return org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil.getExpectedType(this);
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public Element getContextElement()
	{
		return org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil.getContextElement(this);
	}

	/**
	 * &lt;!-- begin-user-doc --&gt;
	 * &lt;!-- end-user-doc --&gt;
	 *
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
	{
		switch (featureID)
		{
		case VSLPackage.ADDITIVE_EXPRESSION__EXP:</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="b"><th>File</th><th>Line</th></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L2742">2742</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/parseTreeConstruction/VSLParsetreeConstructor.html#L5034">5034</a></td></tr><tr class="a"><td colspan='2'><div><pre>			return grammarAccess.getPropertyCallExpressionAccess().getPropertyAssignment_0();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch (index) {
			default:
				return lastRuleCallOrigin.createFollowerAfterReturn(this, index, index, inst);
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if ((value = eObjectConsumer.getConsumable(&quot;property&quot;, true)) == null) {
				return null;
			}
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume(&quot;property&quot;);
			if (value instanceof EObject) { // org::eclipse::xtext::impl::CrossReferenceImpl
				IEObjectConsumer param = createEObjectConsumer((EObject) value);
				if (param.isInstanceOf(grammarAccess.getPropertyCallExpressionAccess().getPropertyPropertyCrossReference_0_0().getType().getClassifier())) {</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="b"><th>File</th><th>Line</th></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/services/VSLGrammarAccess.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/services/VSLGrammarAccess.html#L1545">1545</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/services/VSLGrammarAccess.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/services/VSLGrammarAccess.html#L1695">1695</a></td></tr><tr class="a"><td colspan='2'><div><pre>		}

		// (&quot;(&quot; index=Expression &quot;)&quot;)?
		public Group getGroup_2() {
			return cGroup_2;
		}

		// &quot;(&quot;
		public Keyword getLeftParenthesisKeyword_2_0() {
			return cLeftParenthesisKeyword_2_0;
		}

		// index=Expression
		public Assignment getIndexAssignment_2_1() {
			return cIndexAssignment_2_1;
		}

		// Expression
		public RuleCall getIndexExpressionParserRuleCall_2_1_0() {
			return cIndexExpressionParserRuleCall_2_1_0;
		}

		// &quot;)&quot;
		public Keyword getRightParenthesisKeyword_2_2() {
			return cRightParenthesisKeyword_2_2;
		}

		// (&quot;when&quot; &quot;(&quot; condition=Expression &quot;)&quot;)?
		public Group getGroup_3() {
			return cGroup_3;
		}

		// &quot;when&quot;
		public Keyword getWhenKeyword_3_0() {
			return cWhenKeyword_3_0;
		}

		// &quot;(&quot;
		public Keyword getLeftParenthesisKeyword_3_1() {
			return cLeftParenthesisKeyword_3_1;
		}

		// condition=Expression
		public Assignment getConditionAssignment_3_2() {
			return cConditionAssignment_3_2;
		}

		// Expression
		public RuleCall getConditionExpressionParserRuleCall_3_2_0() {
			return cConditionExpressionParserRuleCall_3_2_0;
		}

		// &quot;)&quot;
		public Keyword getRightParenthesisKeyword_3_3() {
			return cRightParenthesisKeyword_3_3;
		}
	}

	public class InstantObsNameElements extends AbstractParserRuleElementFinder {</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="b"><th>File</th><th>Line</th></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/extensions/CopyOfVSLContextUtil.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/extensions/CopyOfVSLContextUtil.html#L109">109</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/extensions/CopyOfVSLContextUtil.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/extensions/CopyOfVSLContextUtil.html#L289">289</a></td></tr><tr class="a"><td colspan='2'><div><pre>					return ((Property) obj.getId()).getType();
				}
			}
			else if (tmpContainer instanceof Interval) {
				Exception e = new Exception(&quot;Not Implemented: GetExpectedTypeFor_Expression =&gt;  Container instanceof Interval&quot;);
				e.printStackTrace();
			}
			else if (tmpContainer instanceof InstantObsExpression) {
				Exception e = new Exception(&quot;Not Implemented: GetExpectedTypeFor_Expression =&gt;  Container instanceof InstantObsExpression&quot;);
				e.printStackTrace();
			}
			else if (tmpContainer instanceof DurationObsExpression) {
				Exception e = new Exception(&quot;Not Implemented: GetExpectedTypeFor_Expression =&gt;  Container instanceof DurationObsExpression&quot;);
				e.printStackTrace();
			}
			else if (tmpContainer instanceof VariableDeclaration) {
				Exception e = new Exception(&quot;Not Implemented: GetExpectedTypeFor_Expression =&gt;  Container instanceof VariablDeclaration&quot;);
				e.printStackTrace();
			}
			return getExpectedType(tmpContainer);
		}

		return org.eclipse.papyrus.marte.vsl.validation.VSLJavaValidator.getExpectedType();</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="b"><th>File</th><th>Line</th></tr><tr class="a"><td>org/eclipse/papyrus/marte/vsl/validation/VSLJavaValidator.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/validation/VSLJavaValidator.html#L929">929</a></td></tr><tr class="b"><td>org/eclipse/papyrus/marte/vsl/validation/VSLJavaValidator.java</td><td><a href="./xref/org/eclipse/papyrus/marte/vsl/validation/VSLJavaValidator.html#L1108">1108</a></td></tr><tr class="a"><td colspan='2'><div><pre>		Type returnType = null;
		List&lt;String&gt; expectedTypeNames = new ArrayList&lt;String&gt;();
		for (int i = 0; i &lt; b.getOwnedParameters().size(); i++) {
			Parameter p = b.getOwnedParameters().get(i);
			if (p.getDirection() == ParameterDirectionKind.RETURN_LITERAL) {
				returnType = p.getType();
			} else {
				expectedTypeNames.add(p.getType().getName());
			}
		}
		if (returnType == null) {
			String errorMessage = VSLErrorMessage.getOperationWithoutReturnParameterMessage(b.getName());</pre></div></td></tr></table></div>
      </div>
    </div>
    <div class="clear">
      <hr/>
    </div>
    <div id="footer">
      <div class="xright">
              Copyright &#169;  All Rights Reserved.      
            
                  </div>
      <div class="clear">
        <hr/>
      </div>
    </div>
  </body>
</html>
